## cminpack 1.3.4

=== CMakeLists.txt ===
# The name of our project is "CMINPACK". CMakeLists files in this project can
# refer to the root source directory of the project as ${CMINPACK_SOURCE_DIR} and
# to the root binary directory of the project as ${CMINPACK_BINARY_DIR}.
cmake_minimum_required (VERSION 2.6)
project (CMINPACK)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

include(${PROJECT_SOURCE_DIR}/cmake/cminpack_utils.cmake)
# Set version and OS-specific settings
set(CMINPACK_VERSION 1.3.4 CACHE STRING "CMinpack version")
set(CMINPACK_SOVERSION 1 CACHE STRING "CMinpack API version")
DISSECT_VERSION()
GET_OS_INFO()

# Add an "uninstall" target
CONFIGURE_FILE ("${PROJECT_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
    "${PROJECT_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET (uninstall "${CMAKE_COMMAND}" -P
    "${PROJECT_BINARY_DIR}/uninstall_target.cmake")

enable_testing()

if (OS_LINUX)
  option (USE_FPIC "Use the -fPIC compiler flag." ON)
else (OS_LINUX)
  option (USE_FPIC "Use the -fPIC compiler flag." OFF)
endif (OS_LINUX)

option (SHARED_LIBS "Build shared libraries instead of static." OFF)
if (SHARED_LIBS)
  message (STATUS "Building shared libraries.")
  set (LIB_TYPE SHARED)
else (SHARED_LIBS)
  message (STATUS "Building static libraries.")
  set (LIB_TYPE STATIC)
  if(WIN32)
    add_definitions(-DCMINPACK_NO_DLL)
  endif(WIN32)
endif (SHARED_LIBS)

#set(CMAKE_INSTALL_PREFIX ${PROJECT_SOURCE_DIR}/../build)

add_subdirectory (cmake)
add_subdirectory (examples)

set (cminpack_srcs
  cminpack.h cminpackP.h
  chkder.c  enorm.c   hybrd1.c  hybrj.c   lmdif1.c  lmstr1.c  qrfac.c   r1updt.c
  dogleg.c  fdjac1.c  hybrd.c   lmder1.c  lmdif.c   lmstr.c   qrsolv.c  rwupdt.c
  dpmpar.c  fdjac2.c  hybrj1.c  lmder.c   lmpar.c   qform.c   r1mpyq.c  covar.c covar1.c
  minpack.h
  chkder_.c enorm_.c  hybrd1_.c hybrj_.c  lmdif1_.c lmstr1_.c qrfac_.c  r1updt_.c
  dogleg_.c fdjac1_.c hybrd_.c  lmder1_.c lmdif_.c  lmstr_.c  qrsolv_.c rwupdt_.c
  dpmpar_.c fdjac2_.c hybrj1_.c lmder_.c  lmpar_.c  qform_.c  r1mpyq_.c covar_.c
  )
set (cminpack_hdrs
    cminpack.h minpack.h)

add_library (cminpack ${LIB_TYPE} ${cminpack_srcs})

install (TARGETS cminpack 
   LIBRARY DESTINATION ${CMINPACK_LIB_INSTALL_DIR} COMPONENT library
   ARCHIVE DESTINATION ${CMINPACK_LIB_INSTALL_DIR} COMPONENT library
   RUNTIME DESTINATION ${CMINPACK_LIB_INSTALL_DIR} COMPONENT library)
install (FILES ${cminpack_hdrs} DESTINATION ${CMINPACK_INCLUDE_INSTALL_DIR}
    COMPONENT cminpack_hdrs)

if (USE_FPIC AND NOT SHARED_LIBS)
  set_target_properties (cminpack PROPERTIES COMPILE_FLAGS -fPIC)
endif (USE_FPIC AND NOT SHARED_LIBS)

set_target_properties(cminpack PROPERTIES VERSION ${CMINPACK_VERSION} SOVERSION ${CMINPACK_SOVERSION})

=== Makefile ===
PACKAGE=cminpack
VERSION=1.3.4

CC=gcc
CFLAGS= -O3 -g -Wall -Wextra

### The default configuration is to compile the double precision version

### configuration for the LAPACK/BLAS (double precision) version:
## make LIBSUFFIX= CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
#LIBSUFFIX=s
#CFLAGS="-O3 -g -Wall -Wextra -DUSE_CBLAS -DUSE_LAPACK"
CFLAGS_L=$(CFLAGS) -DUSE_CBLAS -DUSE_LAPACK
LDADD_L=-framework Accelerate

### configuration for the float (single precision) version:
## make LIBSUFFIX=s CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
#LIBSUFFIX=s
#CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
CFLAGS_F=$(CFLAGS) -D__cminpack_float__

### configuration for the half (half precision) version:
## make LIBSUFFIX=h CFLAGS="-O3 -g -Wall -Wextra -I/opt/local/include -D__cminpack_half__" LDADD="-L/opt/local/lib -lHalf" CC=g++
#LIBSUFFIX=h
#CFLAGS="-O3 -g -Wall -Wextra -I/opt/local/include -D__cminpack_half__"
#LDADD="-L/opt/local/lib -lHalf"
#CC=g++
CFLAGS_H=$(CFLAGS) -I/opt/local/include -D__cminpack_half__
LDADD_H=-L/opt/local/lib -lHalf
CC_H=$(CXX)

OBJS = \
$(LIBSUFFIX)chkder.o  $(LIBSUFFIX)enorm.o   $(LIBSUFFIX)hybrd1.o  $(LIBSUFFIX)hybrj.o  \
$(LIBSUFFIX)lmdif1.o  $(LIBSUFFIX)lmstr1.o  $(LIBSUFFIX)qrfac.o   $(LIBSUFFIX)r1updt.o \
$(LIBSUFFIX)dogleg.o  $(LIBSUFFIX)fdjac1.o  $(LIBSUFFIX)hybrd.o   $(LIBSUFFIX)lmder1.o \
$(LIBSUFFIX)lmdif.o   $(LIBSUFFIX)lmstr.o   $(LIBSUFFIX)qrsolv.o  $(LIBSUFFIX)rwupdt.o \
$(LIBSUFFIX)dpmpar.o  $(LIBSUFFIX)fdjac2.o  $(LIBSUFFIX)hybrj1.o  $(LIBSUFFIX)lmder.o \
$(LIBSUFFIX)lmpar.o   $(LIBSUFFIX)qform.o   $(LIBSUFFIX)r1mpyq.o  $(LIBSUFFIX)covar.o $(LIBSUFFIX)covar1.o \
$(LIBSUFFIX)chkder_.o $(LIBSUFFIX)enorm_.o  $(LIBSUFFIX)hybrd1_.o $(LIBSUFFIX)hybrj_.o \
$(LIBSUFFIX)lmdif1_.o $(LIBSUFFIX)lmstr1_.o $(LIBSUFFIX)qrfac_.o  $(LIBSUFFIX)r1updt_.o \
$(LIBSUFFIX)dogleg_.o $(LIBSUFFIX)fdjac1_.o $(LIBSUFFIX)hybrd_.o  $(LIBSUFFIX)lmder1_.o \
$(LIBSUFFIX)lmdif_.o  $(LIBSUFFIX)lmstr_.o  $(LIBSUFFIX)qrsolv_.o $(LIBSUFFIX)rwupdt_.o \
$(LIBSUFFIX)dpmpar_.o $(LIBSUFFIX)fdjac2_.o $(LIBSUFFIX)hybrj1_.o $(LIBSUFFIX)lmder_.o \
$(LIBSUFFIX)lmpar_.o  $(LIBSUFFIX)qform_.o  $(LIBSUFFIX)r1mpyq_.o $(LIBSUFFIX)covar_.o

# target dir for install
DESTDIR=/usr/local
#
#  Static library target
#

all: libcminpack$(LIBSUFFIX).a

double:
	$(MAKE) LIBSUFFIX=

lapack:
	$(MAKE) LIBSUFFIX=l CFLAGS="$(CFLAGS_L)" LDADD="$(LDADD_L)"

float:
	$(MAKE) LIBSUFFIX=s CFLAGS="$(CFLAGS_F)"

half:
	$(MAKE) LIBSUFFIX=h CFLAGS="$(CFLAGS_H)" LDADD="$(LDADD_H)" CC="$(CC_H)"

fortran:
	$(MAKE) -C fortran

cuda:
	$(MAKE) -C cuda

check:
	$(MAKE) -C examples check

checkdouble:
	$(MAKE) -C examples checkdouble

checklapack:
	$(MAKE) -C examples checklapack

checkfloat:
	$(MAKE) -C examples checkfloat

checkhalf:
	$(MAKE) -C examples checkhalf

checkfail:
	$(MAKE) -C examples checkfail


libcminpack$(LIBSUFFIX).a:  $(OBJS)
	ar r $@ $(OBJS); ranlib $@

$(LIBSUFFIX)%.o: %.c
	${CC} ${CFLAGS} -c -o $@ $<

install: libcminpack$(LIBSUFFIX).a
	cp libcminpack$(LIBSUFFIX).a ${DESTDIR}/lib
	chmod 644 ${DESTDIR}/lib/libcminpack$(LIBSUFFIX).a
	ranlib -t ${DESTDIR}/lib/libcminpack$(LIBSUFFIX).a # might be unnecessary
	cp minpack.h ${DESTDIR}/include
	chmod 644 ${DESTDIR}/include/minpack.h
	cp cminpack.h ${DESTDIR}/include
	chmod 644 ${DESTDIR}/include/cminpack.h

clean:
	rm -f $(OBJS) libcminpack$(LIBSUFFIX).a
	make -C examples clean
	make -C fortran clean

veryclean: clean
	rm -f *.o libcminpack*.a *.gcno *.gcda *~ #*#
	make -C examples veryclean
	make -C examples veryclean LIBSUFFIX=s
	make -C examples veryclean LIBSUFFIX=h
	make -C examples veryclean LIBSUFFIX=l
	make -C fortran veryclean

.PHONY: dist all double lapack float half fortran cuda check checkhalf checkfail clean veryclean

# COPYFILE_DISABLE=true and COPY_EXTENDED_ATTRIBUTES_DISABLE=true are used to disable inclusion
# of file attributes (._* files) in the tar file on MacOSX
dist:
	mkdir $(PACKAGE)-$(VERSION)
	env COPYFILE_DISABLE=true COPY_EXTENDED_ATTRIBUTES_DISABLE=true tar --exclude-from dist-exclude --exclude $(PACKAGE)-$(VERSION) -cf - . | (cd $(PACKAGE)-$(VERSION); tar xf -)
	tar zcvf $(PACKAGE)-$(VERSION).tar.gz $(PACKAGE)-$(VERSION)
	rm -rf $(PACKAGE)-$(VERSION)

=== cmake/CMakeLists.txt ===
set(PKG_DESC "CMinPack")
set(PKG_EXTERNAL_DEPS "")
set(pkg_conf_file ${CMAKE_CURRENT_BINARY_DIR}/cminpack.pc)
configure_file(cminpack.pc.in ${pkg_conf_file} @ONLY)
install(FILES ${pkg_conf_file}
    DESTINATION ${CMINPACK_LIB_INSTALL_DIR}/pkgconfig/ COMPONENT pkgconfig)

install(FILES FindCMinpack.cmake DESTINATION ${CMAKE_ROOT}/Modules)

=== cuda/Makefile ===
CC=nvcc
CFLAGS= --compile  -I..

SOURCES = $(wildcard *.cu)
OBJECTS = $(SOURCES:.cu=.o)

all: libcuminpack.a

libcuminpack.a:  $(OBJECTS)
	@echo " **************************** "
	@echo " making compiling and library for testing "
	@echo " (cuda needs __device__ source code compiled inline with kernel) "
	@echo " **************************** "
	ar r $@ $(OBJECTS); ranlib $@

%.o: %.cu
	@echo " compiling for testing "
	${CC} ${CFLAGS}  -o $@ $<

clean:
	rm -f *.o libcuminpack.a *~ #*#

=== examples/Makefile ===
#!/usr/bin/make 

# pick up your FORTRAN compiler
#F77=g77
F77=gfortran

# uncomment the following for FORTRAN MINPACK
#MINPACK=-lminpack
#F77C=$(F77)
#F77CFLAGS=-g

# uncomment the following for C MINPACK
MINPACK=../libcminpack$(LIBSUFFIX).a
CC=gcc
CFLAGS=-g -Wall
CPPFLAGS=-I..

FMINPACK=../fortran/libminpack.a

# uncomment the following to debug using valgrind
#VALGRIND=valgrind --tool=memcheck

### The default configuration is to compile the double precision version

### configuration for the LAPACK/BLAS (double precision) version:
## make LIBSUFFIX= CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
#LIBSUFFIX=s
#CFLAGS="-O3 -g -Wall -Wextra -DUSE_CBLAS -DUSE_LAPACK"
CFLAGS_L=$(CFLAGS) -DUSE_CBLAS -DUSE_LAPACK
LDADD_L=-framework vecLib

### configuration for the float (single precision) version:
## make LIBSUFFIX=s CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
#LIBSUFFIX=s
#CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
CFLAGS_F=$(CFLAGS) -D__cminpack_float__

### configuration for the half (half precision) version:
## make LIBSUFFIX=h CFLAGS="-O3 -g -Wall -Wextra -I/opt/local/include -D__cminpack_half__" LDADD="-L/opt/local/lib -lHalf" CC=g++
#LIBSUFFIX=h
#CFLAGS="-O3 -g -Wall -Wextra -I/opt/local/include -D__cminpack_half__"
#LDADD="-L/opt/local/lib -lHalf"
#CC=g++
CFLAGS_H=$(CFLAGS) -I/opt/local/include -D__cminpack_half__
LDADD_H=-L/opt/local/lib -lHalf
CC_H=$(CXX)

FPGM=\
$(LIBSUFFIX)tchkder \
$(LIBSUFFIX)thybrd \
$(LIBSUFFIX)thybrd1 \
$(LIBSUFFIX)thybrj \
$(LIBSUFFIX)thybrj1 \
$(LIBSUFFIX)tlmder \
$(LIBSUFFIX)tlmder1 \
$(LIBSUFFIX)tlmdif \
$(LIBSUFFIX)tlmdif1 \
$(LIBSUFFIX)tlmstr \
$(LIBSUFFIX)tlmstr1 \
$(LIBSUFFIX)ibmdpdr

PGM=\
$(LIBSUFFIX)tenorm_ \
$(LIBSUFFIX)tchkder_ \
$(LIBSUFFIX)thybrd_ \
$(LIBSUFFIX)thybrd1_ \
$(LIBSUFFIX)thybrj_ \
$(LIBSUFFIX)thybrj1_ \
$(LIBSUFFIX)tlmder_ \
$(LIBSUFFIX)tlmder1_ \
$(LIBSUFFIX)tlmdif_ \
$(LIBSUFFIX)tlmdif1_ \
$(LIBSUFFIX)tlmstr_ \
$(LIBSUFFIX)tlmstr1_ \
$(LIBSUFFIX)tfdjac2_ \
$(LIBSUFFIX)ibmdpdr_

CPGM=\
$(LIBSUFFIX)tenormc \
$(LIBSUFFIX)tchkderc \
$(LIBSUFFIX)thybrdc \
$(LIBSUFFIX)thybrd1c \
$(LIBSUFFIX)thybrjc \
$(LIBSUFFIX)thybrj1c \
$(LIBSUFFIX)tlmderc \
$(LIBSUFFIX)tlmder1c \
$(LIBSUFFIX)tlmdifc \
$(LIBSUFFIX)tlmdif1c \
$(LIBSUFFIX)tlmstrc \
$(LIBSUFFIX)tlmstr1c \
$(LIBSUFFIX)tfdjac2c \
$(LIBSUFFIX)ibmdpdrc \
$(LIBSUFFIX)tchkderc_box \
$(LIBSUFFIX)tlmderc_box \
$(LIBSUFFIX)thybrjc_box

FDRVPGM=\
$(LIBSUFFIX)lmddrv_ \
$(LIBSUFFIX)lmfdrv_ \
$(LIBSUFFIX)lmsdrv_ \
$(LIBSUFFIX)hyjdrv_ \
$(LIBSUFFIX)hybdrv_ \
$(LIBSUFFIX)chkdrv_

DRVPGM=\
$(LIBSUFFIX)lmddrv \
$(LIBSUFFIX)lmfdrv \
$(LIBSUFFIX)lmsdrv \
$(LIBSUFFIX)hyjdrv \
$(LIBSUFFIX)hybdrv \
$(LIBSUFFIX)chkdrv

CDRVPGM=\
$(LIBSUFFIX)lmddrvc \
$(LIBSUFFIX)lmfdrvc \
$(LIBSUFFIX)lmsdrvc \
$(LIBSUFFIX)hyjdrvc \
$(LIBSUFFIX)hybdrvc \
$(LIBSUFFIX)chkdrvc

FSRCGEN=tchkder.f thybrd.f thybrd1.f thybrj.f thybrj1.f tlmder.f tlmder1.f \
	tlmdif.f tlmdif1.f tlmstr.f tlmstr1.f
FSRC=$(FSRCGEN) \
	lmddrv.f lmdipt.f ssqfcn.f ssqjac.f lmfdrv.f lmsdrv.f \
	hyjdrv.f hybipt.f vecfcn.f vecjac.f hybdrv.f \
	errjac.f chkdrv.f ibmdpdr.f machar.f
SRC=tchkder_.c thybrd_.c thybrd1_.c thybrj_.c thybrj1_.c tlmder_.c tlmder1_.c \
	tlmdif_.c tlmdif1_.c tlmstr_.c tlmstr1_.c tfdjac2_.c \
	lmddrv_.c lmfdrv_.c lmsdrv_.c \
	hyjdrv_.c hybdrv_.c \
	chkdrv_.c ibmdpdr_.c
CSRC=tchkderc.c thybrdc.c thybrd1c.c thybrjc.c thybrj1c.c tlmderc.c tlmder1c.c \
	tlmdifc.c tlmdif1c.c tlmstrc.c tlmstr1c.c tfdjac2c.c \
	lmddrv.c lmdipt.c ssqfcn.c ssqjac.c lmfdrv.c lmsdrv.c \
	hyjdrv.c hybipt.c vecfcn.c vecjac.c hybdrv.c \
	errjac.c chkdrv.c ibmdpdr.c machar.c

CDRVSRC=lmddrv.c lmfdrv.c lmsdrv.c hyjdrv.c hybdrv.c
REF=test.ref ctest.ref ftest.ref

all:
	@echo "*****************************************************"
	@echo "Please type 'make check' to run all tests at once, or:"
	@echo "*****************************************************"
	@echo "make test: calling FORTRAN CMINPACK from C"
	@echo "make test MINPACK=../fortran/libminpack.a: calling FORTRAN MINPACK from C"
	@echo "make ctest: calling CMINPACK from C"
	@echo "make ftest: calling FORTRAN CMINPACK from FORTRAN"
	@echo "make ftest MINPACK=../fortran/libminpack.a: calling FORTRAN MINPACK from FORTRAN"
	@echo "Intensive (driver) tests:"
	@echo "make testdrv: calling FORTRAN CMINPACK from C"
	@echo "make testdrv MINPACK=../fortran/libminpack.a: calling FORTRAN MINPACK from C"
	@echo "make ctestdrv: calling CMINPACK from C"
	@echo "make ftestdrv: calling FORTRAN CMINPACK from FORTRAN"
	@echo "make ftestdrv MINPACK=../fortran/libminpack.a: calling FORTRAN MINPACK from FORTRAN"

.PHONY: test ctest ctestdrv ctestlmdrv ctesthydrv ctestchkdrv ftest ftestdrv ftestlmdrv ftesthydrv ftestchkdrv check checkdoublec checkdouble checkfloatc checkfloat checkhalfc checkhalf checkfail clean veryclean

test: $(MINPACK) $(PGM)
	@echo "*** Running standard tests (calling MINPACK from C using $(MINPACK))"
	for x in $(PGM); do echo $$x; $(VALGRIND) ./$$x > $$x.out; diff -u ref/`echo $$x.ref|sed -e s/_.ref/c.ref/` $$x.out ; done

testdrv: $(MINPACK) $(FDRVPGM) testlmdrv testhydrv testchkdrv

testlmdrv: $(LIBSUFFIX)lmddrv_ $(LIBSUFFIX)lmfdrv_ $(LIBSUFFIX)lmsdrv_
	@echo "*** Running LM tests (calling MINPACK from C using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/lm.data > $$x.out; diff -u ref/`echo $$x |sed -e s/_/c/`.ref $$x.out ; done

testhydrv: $(LIBSUFFIX)hyjdrv_ $(LIBSUFFIX)hybdrv_
	@echo "*** Running HY tests (calling MINPACK from C using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/hybrd.data > $$x.out; diff -u ref/`echo $$x |sed -e s/_/c/`.ref $$x.out ; done

testchkdrv: $(LIBSUFFIX)chkdrv_
	@echo "*** Running CHK tests (calling MINPACK from C using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/chkder.data > $$x.out; diff -u ref/`echo $$x |sed -e s/_/c/`.ref $$x.out ; done

ctest: $(MINPACK) $(CPGM)
	@echo "*** Running standard tests (calling CMINPACK from C using $(MINPACK))"
	for x in $(CPGM); do echo $$x; $(VALGRIND) ./$$x > $$x.out; diff -u ref/$$x.ref $$x.out ; done

ctestdrv: $(MINPACK) $(CDRVPGM) ctestlmdrv ctesthydrv ctestchkdrv

ctestlmdrv: $(LIBSUFFIX)lmddrvc $(LIBSUFFIX)lmfdrvc $(LIBSUFFIX)lmsdrvc
	@echo "*** Running LM tests (calling CMINPACK from C using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/lm.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done

ctesthydrv: $(LIBSUFFIX)hyjdrvc $(LIBSUFFIX)hybdrvc
	@echo "*** Running HY tests (calling CMINPACK from C using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/hybrd.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done

ctestchkdrv: $(LIBSUFFIX)chkdrvc
	@echo "*** Running CHK tests (calling CMINPACK from C using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/chkder.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done

ftest: $(MINPACK) $(FPGM)
	@echo "*** Running standard tests (calling MINPACK from FORTRAN using $(MINPACK))"
	for x in ${FPGM}; do echo $$x; $(VALGRIND) ./$$x > $$x.out; diff -u ref/$$x.ref $$x.out ; done

ftestdrv: $(MINPACK) $(DRVPGM) ftestlmdrv ftesthydrv ftestchkdrv

ftestlmdrv: $(LIBSUFFIX)lmddrv $(LIBSUFFIX)lmfdrv $(LIBSUFFIX)lmsdrv
	@echo "*** Running LM tests (calling MINPACK from FORTRAN using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/lm.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done

ftesthydrv: $(LIBSUFFIX)hyjdrv $(LIBSUFFIX)hybdrv
	@echo "*** Running HY tests (calling MINPACK from FORTRAN using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/hybrd.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done

ftestchkdrv: $(LIBSUFFIX)chkdrv
	@echo "*** Running CHK tests (calling MINPACK from FORTRAN using $(MINPACK))"
	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/chkder.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done

check: checkdouble checkfloat

checkdoublec:
	$(MAKE) -C .. double 2>&1 > /dev/null
	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null
	-$(MAKE) ctest LIBSUFFIX=
	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null
	-$(MAKE) -k ctestdrv LIBSUFFIX=
	$(MAKE) clean 2>&1 > /dev/null

checkdouble: checkdoublec ../fortran/libminpack.a
	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null
	-$(MAKE) test LIBSUFFIX=
	$(MAKE) clean LIBSUFFIX= MINPACK=../fortran/libminpack.a 2>&1 > /dev/null
	-$(MAKE) test LIBSUFFIX= MINPACK=../fortran/libminpack.a
	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null
	-$(MAKE) ftest LIBSUFFIX=
	$(MAKE) clean LIBSUFFIX= MINPACK=../fortran/libminpack.a 2>&1 > /dev/null
	-$(MAKE) ftest LIBSUFFIX= MINPACK=../fortran/libminpack.a
	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null
	-$(MAKE) -k testdrv LIBSUFFIX=
	$(MAKE) clean 2>&1 > /dev/null

checkfloatc:
	$(MAKE) -C .. float 2>&1 > /dev/null
	$(MAKE) clean LIBSUFFIX=s 2>&1 > /dev/null
	-$(MAKE) ctest LIBSUFFIX=s CFLAGS="$(CFLAGS_F)" 
	$(MAKE) clean LIBSUFFIX=s 2>&1 > /dev/null
	-$(MAKE) -k ctestdrv LIBSUFFIX=s CFLAGS="$(CFLAGS_F)"
	$(MAKE) clean LIBSUFFIX=s 2>&1 > /dev/null

checkfloat: checkfloatc
	$(MAKE) clean LIBSUFFIX=s 2>&1 > /dev/null
	-$(MAKE) test LIBSUFFIX=s CFLAGS="$(CFLAGS_F)"
	$(MAKE) clean LIBSUFFIX=s CFLAGS="$(CFLAGS_F)" 2>&1 > /dev/null
	-$(MAKE) -k testdrv LIBSUFFIX=s CFLAGS="$(CFLAGS_F)" 
	$(MAKE) clean LIBSUFFIX=s 2>&1 > /dev/null

checklapack:
	$(MAKE) -C .. lapack 2>&1 > /dev/null
	$(MAKE) clean LIBSUFFIX=l 2>&1 > /dev/null
	-$(MAKE) ctest LIBSUFFIX=l CFLAGS="$(CFLAGS_L)" LDADD="$(LDADD_L)"
	$(MAKE) clean LIBSUFFIX=l 2>&1 > /dev/null
	-$(MAKE) -k ctestdrv LIBSUFFIX=l CFLAGS="$(CFLAGS_L)" LDADD="$(LDADD_L)"
	$(MAKE) clean LIBSUFFIX=l 2>&1 > /dev/null

checkhalfc:
	$(MAKE) -C .. half 2>&1 > /dev/null
	$(MAKE) clean LIBSUFFIX=h 2>&1 > /dev/null
	-$(MAKE) ctest LIBSUFFIX=h CFLAGS="$(CFLAGS_H)" LDADD="$(LDADD_H)" CC="$(CC_H)"
	$(MAKE) clean LIBSUFFIX=h 2>&1 > /dev/null
	-$(MAKE) -k ctestdrv LIBSUFFIX=h CFLAGS="$(CFLAGS_H)" LDADD="$(LDADD_H)" CC="$(CC_H)"
	$(MAKE) clean LIBSUFFIX=h 2>&1 > /dev/null


checkhalf: checkhalfc
	$(MAKE) clean LIBSUFFIX=h 2>&1 > /dev/null
	-$(MAKE) test LIBSUFFIX=h CFLAGS="$(CFLAGS_H)" LDADD="$(LDADD_H)" CC="$(CC_H)"
	$(MAKE) clean LIBSUFFIX=h 2>&1 > /dev/null
	-$(MAKE) -k testdrv LIBSUFFIX=h CFLAGS="$(CFLAGS_H)" LDADD="$(LDADD_H)" CC="$(CC_H)"
	$(MAKE) clean LIBSUFFIX=h 2>&1 > /dev/null

checkfail: ../fortran/libminpack.a check
	$(MAKE) clean LIBSUFFIX= MINPACK=../fortran/libminpack.a 2>&1 > /dev/null
	-$(MAKE) -k testdrv LIBSUFFIX= MINPACK=../fortran/libminpack.a
	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null
	-$(MAKE) -k ftestdrv LIBSUFFIX=
	$(MAKE) clean LIBSUFFIX= MINPACK=../fortran/libminpack.a 2>&1 > /dev/null
	-$(MAKE) -k ftestdrv LIBSUFFIX= MINPACK=../fortran/libminpack.a
	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null

../libcminpack$(LIBSUFFIX).a:
	$(MAKE) -C ..

../fortran/libminpack.a:
	$(MAKE) -C ../fortran

clean:
	-rm -f $(PGM) $(FDRVPGM) $(DRVPGM) $(CPGM) $(CDRVPGM) $(FPGM)

veryclean: clean
	-rm -f *.o *.gcno *.gcda *.out *~ #*#
	-rm -rf $(PGM:=.dSYM) $(CPGM:=.dSYM) $(CDRVPGM:=.dSYM) $(FPGM:=.dSYM)

${FSRCGEN}: ../doc/minpack-documentation.txt
	cat $< | awk  '					\
	/DRIVER FOR [A-Z1]+ EXAMPLE/{				\
	    pgm=tolower($$4);					\
	    oname="t" pgm ".f";					\
	    $$0 = substr($$0,3);				\
	    print >oname;					\
	    do {						\
		getline; $$0 = substr($$0,3);			\
		if (!/^ +Page$$/) print >>oname;		\
	    }							\
	    while (!/LAST CARD OF SUBROUTINE FCN/);		\
	    getline; $$0 = substr($$0,3); print >>oname;	\
	    getline; $$0 = substr($$0,3); print >>oname;	\
	}'

$(LIBSUFFIX)%: %.f $(MINPACK)
	$(F77) $(FFLAGS) -o $@ $< $(MINPACK)

$(LIBSUFFIX)%: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(MINPACK) $(LDADD) -lm

$(LIBSUFFIX)%.o: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

$(LIBSUFFIX)lmddrv_: $(MINPACK) $(LIBSUFFIX)lmddrv_.o $(LIBSUFFIX)lmdipt.o $(LIBSUFFIX)ssqfcn.o $(LIBSUFFIX)ssqjac.o
	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $^ $(MINPACK) $(LDADD) -lm

$(LIBSUFFIX)lmfdrv_: $(MINPACK) $(LIBSUFFIX)lmfdrv_.o $(LIBSUFFIX)lmdipt.o $(LIBSUFFIX)ssqfcn.o

=== debian/changelog ===
cminpack (1.3.4-4) unstable; urgency=low

  * Fix CI test dependencies

 -- Ole Streicher <olebole@debian.org>  Wed, 21 Oct 2015 10:52:32 +0200

cminpack (1.3.4-3) unstable; urgency=low

  * Update maintainers e-mail address
  * Update standards version to 3.9.6. No changes needed.
  * Include CI tests

 -- Ole Streicher <olebole@debian.org>  Thu, 15 Oct 2015 11:40:27 +0200

cminpack (1.3.4-2) unstable; urgency=low

  * Fix FTBS on several platforms

 -- Ole Streicher <debian@liska.ath.cx>  Thu, 29 May 2014 10:01:08 +0200

cminpack (1.3.4-1) unstable; urgency=low

  * New upstream version
  * Run test suite during build

 -- Ole Streicher <debian@liska.ath.cx>  Wed, 28 May 2014 15:48:50 +0200

cminpack (1.3.3-1) unstable; urgency=low

  * New upstream version.
  * New maintainer. Closes: #726617
  * Migrate repository from svn to git
  * Push Standards-Version to 3.9.5. No changes needed.
  * Change library package name to libcminpack1

 -- Ole Streicher <debian@liska.ath.cx>  Tue, 13 May 2014 11:11:17 +0200

=== debian/control ===
Source: cminpack
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>
Build-Depends: debhelper (>= 9), cmake
Standards-Version: 3.9.6
Homepage: http://devernay.free.fr/hacks/cminpack/index.html
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/cminpack.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/cminpack.git

Package: libcminpack-dev
Section: libdevel
Architecture: any
Depends: libcminpack1 (= ${binary:Version}), ${misc:Depends}
Recommends: minpack-dev
Description: Nonlinear equations and nonlinear least squares problems - development
 Minpack includes software for solving nonlinear equations and nonlinear least
 squares problems. Five algorithmic paths each include a core subroutine and an
 easy-to-use driver. The algorithms proceed either from an analytic
 specification of the Jacobian matrix or directly from the problem functions.
 The paths include facilities for systems of equations with a banded Jacobian
 matrix, for least squares problems with a large amount of data, and for
 checking the consistency of the Jacobian matrix with the functions.
 .
 This is the C re-write of the original fortran minpack implementation.
 .
 This package contains development files needed to build cminpack applications.

Package: libcminpack1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Nonlinear equations and nonlinear least squares problems - runtime
 Minpack includes software for solving nonlinear equations and nonlinear least
 squares problems. Five algorithmic paths each include a core subroutine and an
 easy-to-use driver. The algorithms proceed either from an analytic
 specification of the Jacobian matrix or directly from the problem functions.
 The paths include facilities for systems of equations with a banded Jacobian
 matrix, for least squares problems with a large amount of data, and for
 checking the consistency of the Jacobian matrix with the functions.
 .
 This is the C re-write of the original fortran minpack implementation.
 .
 This package contains the libraries needed to run cminpack applications.

Package: cminpack-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Nonlinear equations and nonlinear least squares problems (doc)
 Minpack includes software for solving nonlinear equations and nonlinear least
 squares problems. Five algorithmic paths each include a core subroutine and an
 easy-to-use driver. The algorithms proceed either from an analytic
 specification of the Jacobian matrix or directly from the problem functions.
 The paths include facilities for systems of equations with a banded Jacobian
 matrix, for least squares problems with a large amount of data, and for
 checking the consistency of the Jacobian matrix with the functions.
 .
 This is the C re-write of the original fortran minpack implementation.
 .
 This package contains documentation files for cminpack.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@ --parallel --buildsystem=cmake

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CMAKE_EXTRA_FLAGS += -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
 -DUSE_FPIC:BOOL=ON \
 -DCMINPACK_LIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
 -DSHARED_LIBS:BOOL=ON \
 -DBUILD_EXAMPLES:BOOL=OFF

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
	$(MAKE) -C examples ctest

override_dh_clean:
	dh_clean
	$(MAKE) -C examples clean

get-orig-source:
	uscan --verbose --force-download --repack --rename

## cminpack 1.3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include(${PROJECT_SOURCE_DIR}/cmake/cminpack_utils.cmake)
 # Set version and OS-specific settings
-set(CMINPACK_VERSION 1.3.4 CACHE STRING "CMinpack version")
+set(CMINPACK_VERSION 1.3.6 CACHE STRING "CMinpack version")
 set(CMINPACK_SOVERSION 1 CACHE STRING "CMinpack API version")
 DISSECT_VERSION()
 GET_OS_INFO()
@@ -20,28 +20,33 @@
 
 enable_testing()
 
-if (OS_LINUX)
+if (OS_LINUX OR ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
   option (USE_FPIC "Use the -fPIC compiler flag." ON)
 else (OS_LINUX)
   option (USE_FPIC "Use the -fPIC compiler flag." OFF)
 endif (OS_LINUX)
 
-option (SHARED_LIBS "Build shared libraries instead of static." OFF)
-if (SHARED_LIBS)
+option (BUILD_SHARED_LIBS "Build shared libraries instead of static." OFF)
+if (BUILD_SHARED_LIBS)
   message (STATUS "Building shared libraries.")
-  set (LIB_TYPE SHARED)
-else (SHARED_LIBS)
+else ()
   message (STATUS "Building static libraries.")
-  set (LIB_TYPE STATIC)
+  set(CMAKE_RELEASE_POSTFIX _s)
+  set(CMAKE_RELWITHDEBINFO_POSTFIX _s)
+  set(CMAKE_DEBUG_POSTFIX _s)
+  set(CMAKE_MINSIZEREL_POSTFIX _s)
   if(WIN32)
     add_definitions(-DCMINPACK_NO_DLL)
   endif(WIN32)
-endif (SHARED_LIBS)
+endif ()
+
+option(USE_BLAS "Compile cminpack using a blas library if possible" ON)
 
 #set(CMAKE_INSTALL_PREFIX ${PROJECT_SOURCE_DIR}/../build)
 
-add_subdirectory (cmake)
-add_subdirectory (examples)
+if(NOT "${CMAKE_PREFIX_PATH}" STREQUAL "")
+  include_directories(${CMAKE_PREFIX_PATH}/include)
+endif()
 
 set (cminpack_srcs
   cminpack.h cminpackP.h
@@ -56,18 +61,37 @@
 set (cminpack_hdrs
     cminpack.h minpack.h)
 
-add_library (cminpack ${LIB_TYPE} ${cminpack_srcs})
+add_library (cminpack ${cminpack_srcs})
 
-install (TARGETS cminpack 
+if (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
+  TARGET_LINK_LIBRARIES(cminpack m)
+endif()
+
+# Link with a BLAS library if requested
+if (USE_BLAS)
+  if (NOT BUILD_SHARED_LIBS)
+    set(BLA_STATIC True)
+  endif()
+  find_package(BLAS)
+  if (BLAS_FOUND)
+    target_link_libraries(cminpack PUBLIC ${BLAS_LIBRARIES})
+    set_target_properties(cminpack PROPERTIES LINK_FLAGS "${BLAS_LINKER_FLAGS}")
+    target_compile_definitions(cminpack PUBLIC -DUSE_CBLAS)
+  endif()
+endif()
+
+install (TARGETS cminpack
    LIBRARY DESTINATION ${CMINPACK_LIB_INSTALL_DIR} COMPONENT library
    ARCHIVE DESTINATION ${CMINPACK_LIB_INSTALL_DIR} COMPONENT library
-   RUNTIME DESTINATION ${CMINPACK_LIB_INSTALL_DIR} COMPONENT library)
+   RUNTIME DESTINATION bin COMPONENT library)
 install (FILES ${cminpack_hdrs} DESTINATION ${CMINPACK_INCLUDE_INSTALL_DIR}
     COMPONENT cminpack_hdrs)
 
-if (USE_FPIC AND NOT SHARED_LIBS)
+if (USE_FPIC AND NOT BUILD_SHARED_LIBS)
   set_target_properties (cminpack PROPERTIES COMPILE_FLAGS -fPIC)
-endif (USE_FPIC AND NOT SHARED_LIBS)
+endif ()
 
 set_target_properties(cminpack PROPERTIES VERSION ${CMINPACK_VERSION} SOVERSION ${CMINPACK_SOVERSION})
 
+add_subdirectory (cmake)
+add_subdirectory (examples)

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PACKAGE=cminpack
-VERSION=1.3.4
+VERSION=1.3.5
 
 CC=gcc
 CFLAGS= -O3 -g -Wall -Wextra
@@ -12,6 +12,12 @@
 #CFLAGS="-O3 -g -Wall -Wextra -DUSE_CBLAS -DUSE_LAPACK"
 CFLAGS_L=$(CFLAGS) -DUSE_CBLAS -DUSE_LAPACK
 LDADD_L=-framework Accelerate
+
+### configuration for the long double version:
+## make LIBSUFFIX=s CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_long_double__"
+#LIBSUFFIX=s
+#CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_long_double__"
+CFLAGS_LD=$(CFLAGS) -D__cminpack_long_double__
 
 ### configuration for the float (single precision) version:
 ## make LIBSUFFIX=s CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
@@ -57,6 +63,9 @@
 lapack:
 	$(MAKE) LIBSUFFIX=l CFLAGS="$(CFLAGS_L)" LDADD="$(LDADD_L)"
 
+longdouble:
+	$(MAKE) LIBSUFFIX=ld CFLAGS="$(CFLAGS_LD)"
+
 float:
 	$(MAKE) LIBSUFFIX=s CFLAGS="$(CFLAGS_F)"
 
@@ -77,6 +86,9 @@
 
 checklapack:
 	$(MAKE) -C examples checklapack
+
+checklongdouble:
+	$(MAKE) -C examples checklongdouble
 
 checkfloat:
 	$(MAKE) -C examples checkfloat
@@ -116,7 +128,7 @@
 	make -C examples veryclean LIBSUFFIX=l
 	make -C fortran veryclean
 
-.PHONY: dist all double lapack float half fortran cuda check checkhalf checkfail clean veryclean
+.PHONY: dist all double lapack longdouble float half fortran cuda check checkhalf checkfail clean veryclean
 
 # COPYFILE_DISABLE=true and COPY_EXTENDED_ATTRIBUTES_DISABLE=true are used to disable inclusion
 # of file attributes (._* files) in the tar file on MacOSX

=== cmake/CMakeLists.txt ===
set(PKG_DESC "CMinPack")
set(PKG_EXTERNAL_DEPS "")
set(pkg_conf_file ${CMAKE_CURRENT_BINARY_DIR}/cminpack.pc)
if (USE_BLAS AND BLAS_FOUND)
    set(PC_CMINPACK_CFLAGS "-DUSE_CBLAS")
    if (NOT "${BLAS_LIBRARIES}" STREQUAL "")
        string(REPLACE ";" " -l" PC_CMINPACK_LIBRARIES "${BLAS_LIBRARIES}")
        set(PC_CMINPACK_LIBRARIES "-l${PC_CMINPACK_LIBRARIES}")
    endif()
    set(PC_CMINPACK_LDFLAGS "${BLAS_LINKER_FLAGS}")
endif()
configure_file(cminpack.pc.in ${pkg_conf_file} @ONLY)
install(FILES ${pkg_conf_file}
    DESTINATION ${CMINPACK_LIB_INSTALL_DIR}/pkgconfig/ COMPONENT pkgconfig)

install(FILES CMinpackConfig.cmake DESTINATION share/cmake/CMinpack)

=== examples/CMakeLists.txt ===
option (BUILD_EXAMPLES "Build the examples and tests." ON)
option (BUILD_EXAMPLES_FORTRAN "Build the FORTRAN examples and tests." OFF)

if (BUILD_EXAMPLES)
  # Make sure the compiler can find include files from our cminpack library.
  include_directories (${CMINPACK_SOURCE_DIR})

  # Make sure the linker can find the cminpack library once it is built.
  link_directories (${CMINPACK_BINARY_DIR})

  set (FPGM tchkder thybrd thybrd1 thybrj thybrj1 tlmder tlmder1 tlmdif tlmdif1 tlmstr tlmstr1)
  set (CPGM ${FPGM} tfdjac2)

  # cmpfiles could be used by runtest.cmake... for now it's unused
  add_executable (cmpfiles cmpfiles.c)

  # inspired by http://www.netlib.org/clapack/clapack-3.2.1-CMAKE/TESTING/CMakeLists.txt
  # except that here we have to compare the output to a reference
  macro(add_minpack_test testname reference)
    set(TEST_OUTPUT "${CMINPACK_BINARY_DIR}/examples/${testname}.out")
    set(TEST_REFERENCE "${CMINPACK_SOURCE_DIR}/examples/ref/${reference}.ref")
    get_target_property(TEST_LOC ${testname} LOCATION)
    add_test(${testname} "${CMAKE_COMMAND}"
      -DTEST=${TEST_LOC}
      -DOUTPUT=${TEST_OUTPUT} 
      -DREFERENCE=${TEST_REFERENCE} 
      -DINTDIR=${CMAKE_CFG_INTDIR}
      -P "${CMINPACK_SOURCE_DIR}/examples/runtest.cmake")
  endmacro(add_minpack_test)

  foreach (source ${CPGM})
    add_executable (${source}_ ${source}_.c)
    target_link_libraries (${source}_ cminpack)
    if (OS_LINUX)
      target_link_libraries (${source}_ m)
    endif (OS_LINUX)
    add_minpack_test(${source}_ ${source}c)
    add_executable (${source}c ${source}c.c)
    target_link_libraries (${source}c cminpack)
    if (OS_LINUX)
      target_link_libraries (${source}c m)
    endif (OS_LINUX)
    add_minpack_test(${source}c ${source}c)
  endforeach(source)
endif (BUILD_EXAMPLES)

if (BUILD_EXAMPLES_FORTRAN)
  enable_language (Fortran OPTIONAL)
  if (CMAKE_Fortran_COMPILER_WORKS)
    foreach (FPGM_item ${FPGM})
      list (APPEND FPGM_SRCS ${CMINPACK_SOURCE_DIR}/examples/${FPGM_item}.f)
    endforeach (FPGM_item ${FPGM})

    # add the executable that will do the generation
    add_executable (genf77tests genf77tests.c)
    get_target_property (GENF77TESTS_EXE genf77tests LOCATION)
    add_custom_command (
      OUTPUT ${FPGM_SRCS}
      COMMAND ${GENF77TESTS_EXE} ${CMINPACK_SOURCE_DIR}/doc/minpack-documentation.txt
      WORKING_DIRECTORY ${CMINPACK_SOURCE_DIR}/examples
      DEPENDS genf77tests
      MAIN_DEPENDENCY ${CMINPACK_SOURCE_DIR}/doc/minpack-documentation.txt
      )
    foreach (source ${FPGM})
      add_executable (${source} ${source}.f)
      target_link_libraries (${source} cminpack)
      add_minpack_test(${source} ${source})
    endforeach (source)
  endif (CMAKE_Fortran_COMPILER_WORKS)
endif (BUILD_EXAMPLES_FORTRAN)

=== examples/Makefile ===
--- 
+++ 
@@ -28,6 +28,12 @@
 #CFLAGS="-O3 -g -Wall -Wextra -DUSE_CBLAS -DUSE_LAPACK"
 CFLAGS_L=$(CFLAGS) -DUSE_CBLAS -DUSE_LAPACK
 LDADD_L=-framework vecLib
+
+### configuration for the long double version:
+## make LIBSUFFIX=s CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_long_double__"
+#LIBSUFFIX=s
+#CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_long_double__"
+CFLAGS_LD=$(CFLAGS) -D__cminpack_long_double__
 
 ### configuration for the float (single precision) version:
 ## make LIBSUFFIX=s CFLAGS="-O3 -g -Wall -Wextra -D__cminpack_float__"
@@ -121,8 +127,8 @@
 FSRCGEN=tchkder.f thybrd.f thybrd1.f thybrj.f thybrj1.f tlmder.f tlmder1.f \
 	tlmdif.f tlmdif1.f tlmstr.f tlmstr1.f
 FSRC=$(FSRCGEN) \
-	lmddrv.f lmdipt.f ssqfcn.f ssqjac.f lmfdrv.f lmsdrv.f \
-	hyjdrv.f hybipt.f vecfcn.f vecjac.f hybdrv.f \
+	lmddrv.f ssqipt.f ssqfcn.f ssqjac.f lmfdrv.f lmsdrv.f \
+	hyjdrv.f neqipt.f vecfcn.f vecjac.f hybdrv.f \
 	errjac.f chkdrv.f ibmdpdr.f machar.f
 SRC=tchkder_.c thybrd_.c thybrd1_.c thybrj_.c thybrj1_.c tlmder_.c tlmder1_.c \
 	tlmdif_.c tlmdif1_.c tlmstr_.c tlmstr1_.c tfdjac2_.c \
@@ -131,8 +137,8 @@
 	chkdrv_.c ibmdpdr_.c
 CSRC=tchkderc.c thybrdc.c thybrd1c.c thybrjc.c thybrj1c.c tlmderc.c tlmder1c.c \
 	tlmdifc.c tlmdif1c.c tlmstrc.c tlmstr1c.c tfdjac2c.c \
-	lmddrv.c lmdipt.c ssqfcn.c ssqjac.c lmfdrv.c lmsdrv.c \
-	hyjdrv.c hybipt.c vecfcn.c vecjac.c hybdrv.c \
+	lmddrv.c ssqipt.c ssqfcn.c ssqjac.c lmfdrv.c lmsdrv.c \
+	hyjdrv.c neqipt.c vecfcn.c vecjac.c hybdrv.c \
 	errjac.c chkdrv.c ibmdpdr.c machar.c
 
 CDRVSRC=lmddrv.c lmfdrv.c lmsdrv.c hyjdrv.c hybdrv.c
@@ -154,7 +160,7 @@
 	@echo "make ftestdrv: calling FORTRAN CMINPACK from FORTRAN"
 	@echo "make ftestdrv MINPACK=../fortran/libminpack.a: calling FORTRAN MINPACK from FORTRAN"
 
-.PHONY: test ctest ctestdrv ctestlmdrv ctesthydrv ctestchkdrv ftest ftestdrv ftestlmdrv ftesthydrv ftestchkdrv check checkdoublec checkdouble checkfloatc checkfloat checkhalfc checkhalf checkfail clean veryclean
+.PHONY: test ctest ctestdrv ctestlmdrv ctesthydrv ctestchkdrv ftest ftestdrv ftestlmdrv ftesthydrv ftestchkdrv check checkdoublec checkdouble checklongdoublec checklongdouble checkfloatc checkfloat checkhalfc checkhalf checkfail clean veryclean
 
 test: $(MINPACK) $(PGM)
 	@echo "*** Running standard tests (calling MINPACK from C using $(MINPACK))"
@@ -164,11 +170,11 @@
 
 testlmdrv: $(LIBSUFFIX)lmddrv_ $(LIBSUFFIX)lmfdrv_ $(LIBSUFFIX)lmsdrv_
 	@echo "*** Running LM tests (calling MINPACK from C using $(MINPACK))"
-	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/lm.data > $$x.out; diff -u ref/`echo $$x |sed -e s/_/c/`.ref $$x.out ; done
+	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/ssq.data > $$x.out; diff -u ref/`echo $$x |sed -e s/_/c/`.ref $$x.out ; done
 
 testhydrv: $(LIBSUFFIX)hyjdrv_ $(LIBSUFFIX)hybdrv_
 	@echo "*** Running HY tests (calling MINPACK from C using $(MINPACK))"
-	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/hybrd.data > $$x.out; diff -u ref/`echo $$x |sed -e s/_/c/`.ref $$x.out ; done
+	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/neq.data > $$x.out; diff -u ref/`echo $$x |sed -e s/_/c/`.ref $$x.out ; done
 
 testchkdrv: $(LIBSUFFIX)chkdrv_
 	@echo "*** Running CHK tests (calling MINPACK from C using $(MINPACK))"
@@ -182,11 +188,11 @@
 
 ctestlmdrv: $(LIBSUFFIX)lmddrvc $(LIBSUFFIX)lmfdrvc $(LIBSUFFIX)lmsdrvc
 	@echo "*** Running LM tests (calling CMINPACK from C using $(MINPACK))"
-	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/lm.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
+	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/ssq.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
 
 ctesthydrv: $(LIBSUFFIX)hyjdrvc $(LIBSUFFIX)hybdrvc
 	@echo "*** Running HY tests (calling CMINPACK from C using $(MINPACK))"
-	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/hybrd.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
+	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/neq.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
 
 ctestchkdrv: $(LIBSUFFIX)chkdrvc
 	@echo "*** Running CHK tests (calling CMINPACK from C using $(MINPACK))"
@@ -200,17 +206,17 @@
 
 ftestlmdrv: $(LIBSUFFIX)lmddrv $(LIBSUFFIX)lmfdrv $(LIBSUFFIX)lmsdrv
 	@echo "*** Running LM tests (calling MINPACK from FORTRAN using $(MINPACK))"
-	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/lm.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
+	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/ssq.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
 
 ftesthydrv: $(LIBSUFFIX)hyjdrv $(LIBSUFFIX)hybdrv
 	@echo "*** Running HY tests (calling MINPACK from FORTRAN using $(MINPACK))"
-	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/hybrd.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
+	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/neq.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
 
 ftestchkdrv: $(LIBSUFFIX)chkdrv
 	@echo "*** Running CHK tests (calling MINPACK from FORTRAN using $(MINPACK))"
 	for x in $^; do echo $$x; $(VALGRIND) ./$$x < testdata/chkder.data > $$x.out; diff -u ref/$$x.ref $$x.out ; done
 
-check: checkdouble checkfloat
+check: checkdouble checklongdouble checkfloat
 
 checkdoublec:
 	$(MAKE) -C .. double 2>&1 > /dev/null
@@ -232,6 +238,21 @@
 	$(MAKE) clean LIBSUFFIX= 2>&1 > /dev/null
 	-$(MAKE) -k testdrv LIBSUFFIX=
 	$(MAKE) clean 2>&1 > /dev/null
+
+checklongdoublec:
+	$(MAKE) -C .. longdouble 2>&1 > /dev/null
+	$(MAKE) clean LIBSUFFIX=ld 2>&1 > /dev/null
+	-$(MAKE) ctest LIBSUFFIX=ld CFLAGS="$(CFLAGS_LD)" 
+	$(MAKE) clean LIBSUFFIX=ld 2>&1 > /dev/null
+	-$(MAKE) -k ctestdrv LIBSUFFIX=ld CFLAGS="$(CFLAGS_LD)"
+	$(MAKE) clean LIBSUFFIX=ld 2>&1 > /dev/null
+
+checklongdouble: checklongdoublec
+	$(MAKE) clean LIBSUFFIX=ld 2>&1 > /dev/null
+	-$(MAKE) test LIBSUFFIX=ld CFLAGS="$(CFLAGS_LD)"
+	$(MAKE) clean LIBSUFFIX=ld CFLAGS="$(CFLAGS_LD)" 2>&1 > /dev/null
+	-$(MAKE) -k testdrv LIBSUFFIX=ld CFLAGS="$(CFLAGS_LD)" 
+	$(MAKE) clean LIBSUFFIX=ld 2>&1 > /dev/null
 
 checkfloatc:
 	$(MAKE) -C .. float 2>&1 > /dev/null
@@ -298,28 +319,3 @@
 	cat $< | awk  '					\
 	/DRIVER FOR [A-Z1]+ EXAMPLE/{				\
 	    pgm=tolower($$4);					\
-	    oname="t" pgm ".f";					\
-	    $$0 = substr($$0,3);				\
-	    print >oname;					\
-	    do {						\
-		getline; $$0 = substr($$0,3);			\
-		if (!/^ +Page$$/) print >>oname;		\
-	    }							\
-	    while (!/LAST CARD OF SUBROUTINE FCN/);		\
-	    getline; $$0 = substr($$0,3); print >>oname;	\
-	    getline; $$0 = substr($$0,3); print >>oname;	\
-	}'
-
-$(LIBSUFFIX)%: %.f $(MINPACK)
-	$(F77) $(FFLAGS) -o $@ $< $(MINPACK)
-
-$(LIBSUFFIX)%: %.c
-	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(MINPACK) $(LDADD) -lm
-
-$(LIBSUFFIX)%.o: %.c
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<
-
-$(LIBSUFFIX)lmddrv_: $(MINPACK) $(LIBSUFFIX)lmddrv_.o $(LIBSUFFIX)lmdipt.o $(LIBSUFFIX)ssqfcn.o $(LIBSUFFIX)ssqjac.o
-	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $^ $(MINPACK) $(LDADD) -lm
-
-$(LIBSUFFIX)lmfdrv_: $(MINPACK) $(LIBSUFFIX)lmfdrv_.o $(LIBSUFFIX)lmdipt.o $(LIBSUFFIX)ssqfcn.o

=== fortran/Makefile ===
#!/usr/bin/make 

# pick up your FORTRAN compiler
#F77=g77
F77=gfortran
FFLAGS=-O3
# uncomment the following for FORTRAN MINPACK
#MINPACK=-lminpack
#F77C=$(F77)
#F77CFLAGS=-g

OBJS = \
chkder.o  enorm.o   hybrd1.o  hybrj.o   lmdif1.o  lmstr1.o  qrfac.o   r1updt.o \
dogleg.o  fdjac1.o  hybrd.o   lmder1.o  lmdif.o   lmstr.o   qrsolv.o  rwupdt.o \
dpmpar.o  fdjac2.o  hybrj1.o  lmder.o   lmpar.o   qform.o   r1mpyq.o  covar.o

# target dir for install
DESTDIR=/usr/local
#
#  Static library target
#
.PHONY: all clean veryclean install

all: libminpack.a

libminpack.a:  $(OBJS)
	ar r $@ $(OBJS); ranlib $@

%.o: %.f
	${F77} ${FFLAGS} -c -o $@ $<

install: libminpack.a
	cp libminpack.a ${DESTDIR}/lib
	chmod 644 ${DESTDIR}/lib/libminpack.a
	ranlib -t ${DESTDIR}/lib/libminpack.a # might be unnecessary

clean:
	rm -f $(OBJS) libminpack.a

veryclean:
	rm -f *.o *.gcno *.gcda *~ #*#

=== cuda/examples/Makefile ===

SOURCES = $(wildcard t*.cu)
TEST_PROGRAMS = $(SOURCES:.cu=)

CC=nvcc
CFLAGS=  -I.. -I../..

all:
	@echo    make cudatest, make clean
	@echo $(TEST_PROGRAMS)


cudatest: clean $(TEST_PROGRAMS)

%:%.cu
	$(CC) $(CFLAGS) -o $@ $<

clean:
	rm -f *.o run.* $(TEST_PROGRAMS)

=== debian/changelog ===
cminpack (1.3.6-6) unstable; urgency=medium

  * Team upload.
  * Bump CMake policy version (Closes: #1112798)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 22:34:42 +0200

cminpack (1.3.6-5) unstable; urgency=medium

  * Push Standards-Version to 4.6.2. No changes
  * Push dh-compat to 13. Remove debian/compat
  * Install CMake file for cminpack
  * Add gitlab-ci.yml
  * Disable failing tests
  * Add lintian overrides for false positive
  * Add LDFLAGS to examples Makefile

 -- Ole Streicher <olebole@debian.org>  Mon, 26 Dec 2022 16:27:09 +0100

cminpack (1.3.6-4) unstable; urgency=medium

  * Further decrease of required CI accuracy
  * Push Standards-Version to 4.3.0. No changes needed

 -- Ole Streicher <olebole@debian.org>  Sun, 23 Dec 2018 23:33:02 +0100

cminpack (1.3.6-3) unstable; urgency=low

  * Update VCS fields to use salsa.d.o
  * Decrease required accuracy for CI tests. Closes: #907720
  * Push Standards-Version to 4.2.1. Change d/copyright format URL to https
  * Push compat to 11
  * Fix repository URL

 -- Ole Streicher <olebole@debian.org>  Sat, 22 Dec 2018 21:34:59 +0100

cminpack (1.3.6-2) unstable; urgency=low

  * Support DEB_BUILD_OPTIONS=nocheck (Closes: #861988)

 -- Ole Streicher <olebole@debian.org>  Mon, 10 Jul 2017 14:31:30 +0200

cminpack (1.3.6-1) unstable; urgency=low

  * New upstream version
  * Push standards-version to 4.0.0. Update VCS urls to https
  * Add Repository and Bug-Database to d/u/metadata

 -- Ole Streicher <olebole@debian.org>  Mon, 19 Jun 2017 17:45:21 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,21 @@
 Source: cminpack
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Ole Streicher <olebole@debian.org>
 Section: libs
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Ole Streicher <olebole@debian.org>
-Build-Depends: debhelper (>= 9), cmake
-Standards-Version: 3.9.6
+Build-Depends: debhelper-compat (= 13),
+               cmake
+Standards-Version: 4.6.2
+Vcs-Browser: https://salsa.debian.org/science-team/cminpack
+Vcs-Git: https://salsa.debian.org/science-team/cminpack.git
 Homepage: http://devernay.free.fr/hacks/cminpack/index.html
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/cminpack.git
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/cminpack.git
 
 Package: libcminpack-dev
+Architecture: any
+Multi-Arch: same
 Section: libdevel
-Architecture: any
-Depends: libcminpack1 (= ${binary:Version}), ${misc:Depends}
+Depends: libcminpack1 (= ${binary:Version}),
+         ${misc:Depends}
 Recommends: minpack-dev
 Description: Nonlinear equations and nonlinear least squares problems - development
  Minpack includes software for solving nonlinear equations and nonlinear least
@@ -29,7 +32,9 @@
 
 Package: libcminpack1
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Nonlinear equations and nonlinear least squares problems - runtime
  Minpack includes software for solving nonlinear equations and nonlinear least
@@ -45,8 +50,9 @@
  This package contains the libraries needed to run cminpack applications.
 
 Package: cminpack-doc
+Architecture: all
+Multi-Arch: foreign
 Section: doc
-Architecture: all
 Depends: ${misc:Depends}
 Description: Nonlinear equations and nonlinear least squares problems (doc)
  Minpack includes software for solving nonlinear equations and nonlinear least

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CMAKE_EXTRA_FLAGS += -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
 -DUSE_FPIC:BOOL=ON \
 -DCMINPACK_LIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
 -DBUILD_SHARED_LIBS:BOOL=ON \
 -DBUILD_EXAMPLES:BOOL=OFF \
 -DCMAKE_POLICY_VERSION_MINIMUM=3.10

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
ifeq ($(filter $(DEB_BUILD_OPTIONS),nocheck),)
	$(MAKE) -C examples ctest
else
	@echo '"DEB_BUILD_OPTIONS" has "nocheck". Skipping tests'
endif

override_dh_clean:
	dh_clean
	$(MAKE) -C examples clean

get-orig-source:
	uscan --verbose --force-download --repack --rename

=== debian/tests/control ===
Tests: cminpack-test
Depends: libcminpack-dev, gcc, libc6-dev

=== debian/watch ===
version=3
http://devernay.free.fr/hacks/cminpack/index.html cminpack-(.*)\.tar\.gz
